import _Dialog from "@alifd/next/es/dialog";
import _Message from "@alifd/next/es/message";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { material, project } from '@alilc/lowcode-engine';
import { filterPackages } from '@alilc/lowcode-plugin-inject';
import { IPublicEnumTransformStage } from '@alilc/lowcode-types';
import DefaultPageSchema from './defaultPageSchema.json';
import DefaultI18nSchema from './defaultI18nSchema.json';
var generateProjectSchema = function generateProjectSchema(pageSchema, i18nSchema) {
  return {
    componentsTree: [pageSchema],
    componentsMap: material.componentsMap,
    version: '1.0.0',
    i18n: i18nSchema
  };
};
export var saveSchema = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(scenarioName) {
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          setProjectSchemaToLocalStorage(scenarioName);
          _context.next = 4;
          return setPackagesToLocalStorage(scenarioName);
        case 4:
          _Message.success('成功保存到本地');
        case 5:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function saveSchema(_x) {
    return _ref.apply(this, arguments);
  };
}();
export var resetSchema = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(scenarioName) {
    var _project$simulatorHos;
    var defaultSchema;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          _context2.prev = 1;
          _context2.next = 4;
          return new Promise(function (resolve, reject) {
            _Dialog.confirm({
              content: '确定要重置吗？您所有的修改都将消失！',
              onOk: function onOk() {
                resolve();
              },
              onCancel: function onCancel() {
                reject();
              }
            });
          });
        case 4:
          _context2.next = 9;
          break;
        case 6:
          _context2.prev = 6;
          _context2.t0 = _context2["catch"](1);
          return _context2.abrupt("return");
        case 9:
          defaultSchema = generateProjectSchema(DefaultPageSchema, DefaultI18nSchema);
          project.importSchema(defaultSchema);
          (_project$simulatorHos = project.simulatorHost) === null || _project$simulatorHos === void 0 ? void 0 : _project$simulatorHos.rerender();
          setProjectSchemaToLocalStorage(scenarioName);
          _context2.next = 15;
          return setPackagesToLocalStorage(scenarioName);
        case 15:
          _Message.success('成功重置页面');
        case 16:
        case "end":
          return _context2.stop();
      }
    }, _callee2, null, [[1, 6]]);
  }));
  return function resetSchema(_x2) {
    return _ref2.apply(this, arguments);
  };
}();
var getLSName = function getLSName(scenarioName, ns) {
  if (ns === void 0) {
    ns = 'projectSchema';
  }
  return scenarioName + ":" + ns;
};
export var getProjectSchemaFromLocalStorage = function getProjectSchemaFromLocalStorage(scenarioName) {
  if (!scenarioName) {
    console.error('scenarioName is required!');
    return;
  }
  var localValue = window.localStorage.getItem(getLSName(scenarioName));
  if (localValue) {
    return JSON.parse(localValue);
  }
  return undefined;
};
var setProjectSchemaToLocalStorage = function setProjectSchemaToLocalStorage(scenarioName) {
  if (!scenarioName) {
    console.error('scenarioName is required!');
    return;
  }
  window.localStorage.setItem(getLSName(scenarioName), JSON.stringify(project.exportSchema(IPublicEnumTransformStage.Save)));
};
var setPackagesToLocalStorage = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(scenarioName) {
    var packages;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          if (scenarioName) {
            _context3.next = 3;
            break;
          }
          console.error('scenarioName is required!');
          return _context3.abrupt("return");
        case 3:
          _context3.next = 5;
          return filterPackages(material.getAssets().packages);
        case 5:
          packages = _context3.sent;
          window.localStorage.setItem(getLSName(scenarioName, 'packages'), JSON.stringify(packages));
        case 7:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return function setPackagesToLocalStorage(_x3) {
    return _ref3.apply(this, arguments);
  };
}();
export var getPackagesFromLocalStorage = function getPackagesFromLocalStorage(scenarioName) {
  if (!scenarioName) {
    console.error('scenarioName is required!');
    return;
  }
  return JSON.parse(window.localStorage.getItem(getLSName(scenarioName, 'packages')) || '{}');
};
export var getProjectSchema = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(scenarioName) {
    var pageSchema;
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          _context4.next = 3;
          return getPageSchema(scenarioName);
        case 3:
          pageSchema = _context4.sent;
          return _context4.abrupt("return", generateProjectSchema(pageSchema, DefaultI18nSchema));
        case 5:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return function getProjectSchema(_x4) {
    return _ref4.apply(this, arguments);
  };
}();
export var getPageSchema = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5(scenarioName) {
    var _getProjectSchemaFrom, _getProjectSchemaFrom2;
    var pageSchema;
    return _regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          pageSchema = (_getProjectSchemaFrom = getProjectSchemaFromLocalStorage(scenarioName)) === null || _getProjectSchemaFrom === void 0 ? void 0 : (_getProjectSchemaFrom2 = _getProjectSchemaFrom.componentsTree) === null || _getProjectSchemaFrom2 === void 0 ? void 0 : _getProjectSchemaFrom2[0];
          if (!pageSchema) {
            _context5.next = 4;
            break;
          }
          return _context5.abrupt("return", pageSchema);
        case 4:
          return _context5.abrupt("return", DefaultPageSchema);
        case 5:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return function getPageSchema(_x5) {
    return _ref5.apply(this, arguments);
  };
}();
export var getPreviewLocale = function getPreviewLocale(scenarioName) {
  var key = getLSName(scenarioName, 'previewLocale');
  return window.localStorage.getItem(key) || 'zh-CN';
};
export var setPreviewLocale = function setPreviewLocale(scenarioName, locale) {
  var key = getLSName(scenarioName, 'previewLocale');
  window.localStorage.setItem(key, locale || 'zh-CN');
  window.location.reload();
};