"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.createLinkFetchHandler = createLinkFetchHandler;
exports.createRemoteFetchHandler = createRemoteFetchHandler;
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _axios = _interopRequireDefault(require("axios"));
function createLinkFetchHandler(config) {
  return /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(options, ctx) {
      var funcStr, willFetch, response, data, returnData, _funcStr, didFetch, _return, _return2;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (options.willFetch) {
              funcStr = options.willFetch;
              willFetch = new Function("return (" + funcStr + ")");
              willFetch(options);
            }
            _context.next = 3;
            return _axios["default"].request({
              url: options.uri + ("?uniqueId=" + options.uniqueId),
              method: options.method
              // data: options.params,
              // params: options.params
            });
          case 3:
            response = _context.sent;
            data = response.data.result;
            returnData = data;
            if (!options.didFetch) {
              _context.next = 21;
              break;
            }
            _funcStr = options.didFetch; // eslint-disable-next-line no-new-func
            didFetch = new Function("return (" + _funcStr + ")");
            _context.prev = 9;
            _context.next = 12;
            return didFetch()(data);
          case 12:
            returnData = _context.sent;
            _context.next = 17;
            break;
          case 15:
            _context.prev = 15;
            _context.t0 = _context["catch"](9);
          case 17:
            _return = {
              data: returnData
            };
            return _context.abrupt("return", _return);
          case 21:
            _return2 = {
              data: returnData
            };
            return _context.abrupt("return", _return2);
          case 23:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[9, 15]]);
    }));
    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
}
function createRemoteFetchHandler(config) {
  return /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(options, ctx) {
      var funcStr, willFetch, response, dataStr, data, _funcStr2, didFetch;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            if (options.willFetch) {
              funcStr = options.willFetch; // eslint-disable-next-line no-new-func
              willFetch = new Function("return (" + funcStr + ")");
              willFetch(options);
            }
            _context2.next = 3;
            return _axios["default"].request({
              url: options.uri,
              method: options.method,
              data: options.params,
              params: options.params
            });
          case 3:
            response = _context2.sent;
            dataStr = response.data.jsonstr;
            data = JSON.parse(dataStr).result;
            if (options.didFetch) {
              _funcStr2 = options.didFetch; // eslint-disable-next-line no-new-func
              didFetch = new Function("return (" + _funcStr2 + ")");
              response = didFetch(response);
            }
            return _context2.abrupt("return", (0, _extends2["default"])({}, response, {
              data: data
            }));
          case 8:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    }));
    return function (_x3, _x4) {
      return _ref2.apply(this, arguments);
    };
  }();
}
var appHelper = {
  requestHandlersMap: {
    link: createLinkFetchHandler(),
    remote: createRemoteFetchHandler()
  },
  utils: {},
  constants: {}
};
var _default = exports["default"] = appHelper;